using System;
using System.Drawing; 
using System.Collections;


namespace Path
{
	/// <summary>
	/// Summary description for Class.
	/// </summary>
public class super_path
{
	Cartesio c;
	path p;
	public Point P1;
	public Point P2;
	public Point Pa;
	public Point N1;
	public Point N2;
	public bool Error;
	ArrayList VisibleP1 = new ArrayList();
	ArrayList VisibleP2 = new ArrayList();

		public super_path(Point p1,Point p2 , Cartesio cart){
		P1 = p1;
		P2 = p2;
		c = cart;
		Pa = P1;
		Error = false;
		if (c.Collide(p1))
			Error = true;
		if (c.Collide(p2))
			Error = true;
		if (! Error)
		{
			VisibleP1.Clear();
			VisibleP2.Clear();
			det_vis(); //determino insieme nodi che vedono P1 e P2
			det_first_last();	//determino distanza minore N1 -- N2
			Console.WriteLine( " N1 " + N1 + " N2 " + N2 );
			initialize();
		}
		}

/*	public bool connected()
	{
	foreach(Arc a in N1.)
	}*/

	private void det_vis()
	{
		/* det l'ultimo ai_node per accedere a P1 e P2*/

		foreach (Node no in c.ai_nodes)
		{
			if (c.CanGo(P2,no.P))
			{
				VisibleP2.AddRange(no.ai_stars);
			}
			if (c.CanGo(P1,no.P))
			{
				VisibleP1.AddRange(no.ai_stars);
			}

		}


	}


	private void det_first_last()
	{
		float dista = -1;
		foreach (Star s1 in VisibleP1)
		{
				foreach (Star s2 in VisibleP2)
				{
					if (s1.To == s2.From)
					{
					 float di = c.dist(s1.From,P1) + c.dist(s2.From,P2) + s1.Dist;
					 if (dista == -1 )
					 {
						dista = di;
						N1 = s1.From;
						N2 = s2.From;
					 }
					 if (dista > di )
					 {
						dista = di;
						N1 = s1.From;
						N2 = s2.From;
					 }
					}
				}
		}

		// to chek the connection (N1 ca reach N2)
		bool found = false;
		foreach (Star s1 in VisibleP1)
		{
		if ( (s1.From == N1) & (s1.To == N2) & (s1.Dist > 0) )
			found = true;
		}
		if (!(found))
			Error = true;
		// to chek the connection (N1 ca reach N2)

	}


	private void initialize()
	{
		if (c.CanGo(Pa,P2))
		{
			p = new path(Pa,P2);
		}
		else
		{
			if (c.CanGo(Pa,N2))	
			{
				p = new path(Pa,N2);				
			}
			else
			{
				p = new path(Pa,N1);
			}
		}
	}

	private void initializeN()
	{
		Point nextP = Pa;
		if (c.CanGo(Pa,P2))
		{
			nextP = P2;
		}
		else
		{
				if (c.CanGo(Pa,N2)) 
				{
					nextP = N2;
				}
				else
				{		
					foreach (Node no in c.ai_nodes)
					{
					  if (no.P == Pa)
					    foreach (Star s in no.ai_stars)
					    {	
						if (s.To == N2)
						{
							nextP = s.Throu;
						}
					    }
					}

				}
		}
		p = new path(Pa,nextP);
	}
	



	
	public bool Next()
	{
		if ( Error)
			return (true);
		if (P2 == Pa) 
		{
			return (true);
		}
		else
		{
			if (!p.endofpath())
			{
				Pa = p.next();
			}
			else
			{
				initializeN();
			}
		}
		return (false);
	}
}


public class path
/* gestisce il percorso tra 2 punti S ed F supponendo assenza di ostacoli*/
{
	public Point S;
	public Point F;
	public Point C;
	private float M;
	private float Q;

	public path(Point s, Point f)
	{
		S = s;
		F = f;
		C = s;

		M = 0f;
		Q = S.X;
		if ((F.X - S.X) != 0 )
		{
			M = (float)(F.Y - S.Y) / (F.X - S.X);
			Q = S.Y - (M * S.X);
		}
	}

	public void set_rel_point(Point s)
	{
	/* even. utile per movimento parallelo ad S ---- F*/
		C = s;
	}

	public Point next()
	{
	/* controllo fine percorso */
	if (endofpath())
	{ return(F);}

		if (F.X == S.X)
		{
			if (S.Y < F.Y)
			{C.Y ++;}
			else
			{C.Y --;}
			return (C);
		}

		if (F.Y == S.Y)
		{
			if (S.X < F.X)
			{ C.X ++; }
			else
			{ C.X --; }
			return (C);
		}



		if ((M > -1) && (M < 1))
		{
			 if (S.X < F.X)
			 {
				C.X++;
			 }
			 else
			 {
				if (S.X > F.X)
				{
					 C.X--;
				}
			 }
			 C.Y	 = (F_Y(M, Q, C.X));
		}
			else
		{
			 if (S.Y < F.Y)
			 {
				C.Y++;
			 }
			 else
			 {
				if (S.Y > F.Y)
					{
						C.Y--;
					}
			 }
			C.X	 = (F_X(M, Q, C.Y));
		}

	return (C);
	}

	public Point prev()
	{
	/* da implementare */
	return(C);
	}

	public Boolean endofpath()
	{
		return(C == F);
	}

	public float dist()
	{
		return (float)( Math.Sqrt(Math.Pow(F.Y - S.Y,2) + Math.Pow(F.X - S.X,2)) );
	}

	public float relat_dist()
	{
		return (float)( Math.Sqrt(Math.Pow(F.Y - C.Y,2) + Math.Pow(F.X - C.X,2)) );
	}


	public float int_dist()
	{
		return ( Math.Max( (F.Y - S.Y) , (F.X - S.X)) );
	}

	public float int_relat_dist()
	{
		return ( Math.Max( (F.Y - C.Y) , (F.X - C.X)) );
	}


	private int F_Y(float m, float q, int x)
	{
	return (int)(Math.Round(( m * x + q)));
	}

	private int F_X(float m, float q, int y)
	// dato Y restituisce X (funzione Y=mX+q)
	{
	if (m == 0)
		{ return (int)(q); }
	else
		{ return (int) Math.Round((( y - q)/m)); }
	}

	public int F_Y(int x)
	{
	return (int)(Math.Round(( M * x + Q)));
	}

	public int F_X(int y)
	// dato Y restituisce X (funzione Y=mX+q)
	{
	if (M == 0)
		{ return (int)(Q); }
	else
		{ return (int) Math.Round((( y - Q)/M)); }
	}


}

	public class Wall /* wall */
	{
	public int X;
	public int Y;
	public int Hei;
	public int Wid;
	public Wall(int x1,int y1,int W,int H)
	{
		X=x1;
		Y=y1;
		Hei=H;
		Wid=W;
	}

	public Wall(Point P1,Point P2)
	{
		int x1 = min(P1.X,P2.X);
		int x2 = max(P1.X,P2.X);
		int y1 = min(P1.Y,P2.Y);
		int y2 = max(P1.Y,P2.Y);
		X=x1;
		Y=y1;
		Hei=abs(y2)-abs(y1);
		Wid=abs(x2)-abs(x1);
	}

	private int min(int i,int j)
	{
	if (i<=j)
		return(i);
	else
		return(j);
	}

	private int max(int i,int j)
	{
	if (i>=j)
		return(i);
	else
		return(j);
	}
	private int abs(int i)
	{
	if (i<0)
		return(i*(-1));
	else
		return(i);
	}


	public Wall(int x,int y)
	{
		X=x;
		Y=y;
		Hei=1;
		Wid=1;
	}

    }


//***********************************************************************+
/* 
	NUOVA GESTIONE: introduzione oggetto Node con gestione delegate per comunicazione tra nodi adiacenti
*/


public delegate void SendStarEventHandler
  (object sender, SendMessageEventArgs e);

public delegate void SendMessageEventHandler
  (object sender, SendMessageEventArgs e);

public class SendMessageEventArgs : EventArgs
{

  public float Dist;
  public Node From;
  public Node To;
  public Node Trou;

  public SendMessageEventArgs(float dist, Node from, Node to,Node trou)
  {
    this.Dist = dist;
    this.From = from;
    this.To = to;
    this.Trou = trou;
  }

}

    public class Node /* Node */
	{
	public Point P;
	public float Dist;
	public ArrayList arcs = new ArrayList(); /* listra nodi adiacenti*/
	public ArrayList ai_stars = new ArrayList();
	public event SendMessageEventHandler SendMessage;
	public event SendStarEventHandler SendStar;


	public Node(int x1,int y1)
	{
		P.X=x1;
		P.Y=y1;
		Dist = -1;
	}
	public Node(Point p1)
	{
		P = p1;
		Dist = -1;
	}
	public void Addarc(Node n1 )
	/* consente di legare altri nodi a questo */
	{
		arcs.Add(n1);
		
		// aggiungo i nodi legati a questo tra i listeners dei messaggi inviati da questo nodo
    		this.SendMessage += new SendMessageEventHandler(n1.OnRecivedMessage);
	}

	public void Remarc(Node n1 )
	/* consente di eliminare un legame */
	{
		arcs.Remove(n1);
		
		// aggiungo i nodi legati a questo tra i listeners dei messaggi inviati da questo nodo
    		this.SendMessage -= new SendMessageEventHandler(n1.OnRecivedMessage);
	}

	public void path_from(Node n)
	{
		if (SendMessage != null)
		{
			SendMessage(this, new SendMessageEventArgs(0 ,this,n,this));
		}
		else
		{
			Console.WriteLine( "from " + this.P + " to " + n.P  );				
		}
	}
	
	public void OnRecivedMessage(object sender, SendMessageEventArgs e)
 	{
		/*    gestione del messaggio : ovvero se non gi satto gestito in precedenza .. allora 
			fare forward a tutti i nodi legati */

		if (e.To == this) 
		{
	    			if (SendStar != null)
					{
					SendStar(this, new SendMessageEventArgs(e.Dist + (cal_dist(this,e.Trou)) ,e.To,e.From,e.Trou));
					}

		}
		else
		{
			if ( (e.Dist < Dist) | (Dist == -1))
			{
				Dist = e.Dist;
	    			if (SendMessage != null)
					{
					SendMessage(this, new SendMessageEventArgs(e.Dist + (cal_dist(this,e.Trou)) ,e.From,e.To,this));
					}
			}
		}

	}

	private float cal_dist(Node S, Node F)
	{
		return (float)( Math.Sqrt(Math.Pow(F.P.Y - S.P.Y,2) + Math.Pow(F.P.X - S.P.X,2)) );	
	}

    }		


//***********************************************************************+



    public class Star /* wall */
    {
	public Point From;
	public Point Throu;
	public Point To;
	public float Dist;

	public Star(Point p1,Point p2,Point p3,float d)
	{
		From=p1;
		Throu=p2;
		To=p3;
		Dist=d;
	}
	}

//***********************************************************************+

	public class Cartesio{
	public int Xmax;
	public int Ymax;
		public ArrayList walls = new ArrayList();
		public ArrayList ai_nodes = new ArrayList();

		public Cartesio(int x,int y){
		Xmax = x;
		Ymax = y;
	//	walls.Add(null);
		}

		public void All_AI_Nodes(){
		foreach (Node p in ai_nodes)
		{
			foreach (Node q in ai_nodes)
			{
			if (p != q)
				{
				  if (! CanGo(p.P,q.P) )
				  {
					//Console.WriteLine( "from " + p.P + " to " + q.P  );
					p.path_from(q);
					foreach (Node q1 in ai_nodes)
					{ q1.Dist = -1;}
				  }
				  else
				  {
					upd_ai_star(p,q, q ,dist(p.P,q.P));
				  }
				}
			}

		}

	}

	public void OnRecivedStar(object sender, SendMessageEventArgs e)
	{
		upd_ai_star(e.From,e.Trou, e.To ,e.Dist);
	}

		public void Clear_ai_nodes(){

		foreach (Node p in ai_nodes)
		{
			foreach (Node q in ai_nodes)
			{
				if (p != q )
				{
				 if (p.arcs.Contains(q))
				 {
					p.Remarc(q);
				 }
				}
			}
		}

		ai_nodes.Clear();
		}


		public Point Up(Point P)
		{
		/*point up to P*/
		return (new Point(P.X,P.Y-1));
		}

		public Point Down(Point P)
		{
		/*point down to P*/
		return (new Point(P.X,P.Y+1));
		}

		public Point Left(Point P)
		{
		/*point left to P*/
		return (new Point(P.X-1,P.Y));
		}

		public Point Right(Point P)
		{
		return (new Point(P.X+11,P.Y));
		}

		public Point Up_Left(Point P)
		{
		/*point Up and Left to P*/
		return (new Point(P.X-1,P.Y-1));
		}

		public Point Up_Right(Point P)
		{
		return (new Point(P.X+1,P.Y-1));
		}

		public Point Down_Right(Point P)
		{
		return (new Point(P.X+1,P.Y+1));
		}

		public Point Down_Left(Point P)
		{
		return (new Point(P.X-1,P.Y+1));
		}



		public void Create_ai_nodes(){
		/* per ogni muro.. considero come nodo il punti esterni ai vertici*/

		int itera = 0;
		Console.WriteLine( "Creates Nodes"  );
		foreach (Wall w in walls)
		{
		if ( (!Collide(new Point(w.X,w.Y),w))
			|
			 (( !Collide(Left(new Point(w.X,w.Y)) ) ) &
			  ( !Collide(Up(new Point(w.X,w.Y)) ) ))
			)
		 if ( (w.X-1 >=0) & (w.Y-1 >=0))
			{
				Point p = new Point(w.X-1,w.Y-1);
				Node n = new Node(p);
				if (!Collide(n.P))
				{
					n.SendStar += new SendStarEventHandler(this.OnRecivedStar);
					if (!ai_nodes.Contains(n))
					{
					ai_nodes.Add(n) ;
					}
				}
			}
		if ( (!Collide(new Point(w.X,w.Y+w.Hei),w))
			|
			 (( !Collide(Left(new Point(w.X,w.Y+w.Hei)) ) ) &
			  ( !Collide(Down(new Point(w.X,w.Y+w.Hei)) ) ))
			)
		 if ( (w.X-1 >=0) & (w.Y+w.Hei+1 >=0) & (w.Y+w.Hei+1 <=Ymax))
			{
				Point p = new Point(w.X-1,w.Y+w.Hei+1);
				Node n = new Node(p);
				if (!Collide(n.P))
				{
					n.SendStar += new SendStarEventHandler(this.OnRecivedStar);
					if (!ai_nodes.Contains(n))
					{
					ai_nodes.Add(n) ;
					}
				}
			}
		if( (!Collide(new Point(w.X+w.Wid,w.Y+w.Hei),w)) //optim!
			|
			 (( !Collide(Right(new Point(w.X+w.Wid,w.Y+w.Hei)) ) ) &
			  ( !Collide(Down(new Point(w.X+w.Wid,w.Y+w.Hei)) ) ))
			)

		 if ( (w.X+w.Wid+1 >=0) & (w.Y+w.Hei+1 >=0)& (w.Y+w.Hei+1 <=Ymax) & (w.X+w.Wid+1 <=Xmax))
			{
				Point p = new Point(w.X+w.Wid+1,w.Y+w.Hei+1);
				Node n = new Node(p);

				if (!Collide(n.P))
				{
					n.SendStar += new SendStarEventHandler(this.OnRecivedStar);
					if (!ai_nodes.Contains(n))
					{
					ai_nodes.Add(n) ;
					}
				}
			}
		if ( (!Collide(new Point(w.X+w.Wid,w.Y),w)) //optim!
			|
			 (( !Collide(Right(new Point(w.X+w.Wid,w.Y)) ) ) &
			  ( !Collide(Up(new Point(w.X+w.Wid,w.Y)) ) ))
			)

		 if ( (w.X+w.Wid+1 >=0) & (w.Y-1 >=0)& (w.X+w.Wid+1 <=Xmax))
			{
				Point p = new Point(w.X+w.Wid+1,w.Y-1);
				Node n = new Node(p);
				 if (!Collide(n.P))
				 {
					n.SendStar += new SendStarEventHandler(this.OnRecivedStar);
					if (!ai_nodes.Contains(n))
					{
					ai_nodes.Add(n) ;
					}
				 }
			}
				itera ++;
		}

		itera = 0;
		Console.WriteLine( "Creates Arcs"  );
		/* creo archi di visibilit*/
		foreach (Node p in ai_nodes)
		{
			foreach (Node q in ai_nodes)
			{
				if (p != q )
				{
				 if (CanGo(p.P,q.P) )
				 {
					p.Addarc(q);
					itera ++;
				 }
				}
			}
		}
		Console.WriteLine( itera  );
		itera =0;


		All_AI_Nodes();

		}

	private void upd_ai_star(Node f,Node tr, Node t ,float d)
	{
		bool tro = false;
		foreach (Star s in f.ai_stars)
		{
			//if ( (s.From == f.P) & (s.To == t.P)  )
			if  (s.To == t.P)
			{
				tro=true;
				if ( (s.Dist >= d) )
				{
					s.Dist = d;
					s.Throu = tr.P;
				}
			}
		}
		if (! tro)
		{
			Star s1 = new Star(f.P,tr.P,t.P,d);
			f.ai_stars.Add(s1);
		}
	}

		public void AddWall(int X,int Y){
		Wall NewWall = new Wall(X,Y);
				walls.Add(NewWall);
		}
		public void AddWall(int X1,int Y1, int W,int H){
		/* aggiunge un rettangolo */
		Wall NewWall = new Wall(X1,Y1,W,H);
				walls.Add(NewWall);
		}

		public void AddWall(Point P1,Point P2){
		/* aggiunge un rettangolo */
		Wall NewWall = new Wall(P1,P2);
				walls.Add(NewWall);
		}


	private Boolean Collide(Point P,Wall w1)
	/* se il punto P  contenuto in un wall*/
	{
	foreach (Wall w in walls)
	{
		if (! (w==w1) )
		 if ( (P.X >= w.X) & (P.X <= (w.X + w.Wid)))
		 {
			if ((P.Y >= w.Y) & (P.Y <= w.Y+w.Hei))
			{ return(true); }
		 }
	}
		return (false);
	}


	public Boolean Collide(Point P)
	/* se il punto P  contenuto in un wall*/
	{
	foreach (Wall w in walls)
	{
		if ( (P.X >= w.X) & (P.X <= (w.X + w.Wid)))
		{
			if ((P.Y >= w.Y) & (P.Y <= w.Y+w.Hei))
			{ return(true); }
		}
	}
		return (false);
	}

	public Boolean CanGo(Point P1,Point P2)
	{
		/* P1 pu raggiungere P2 */
		/* P1 vede P2 */
		path Npath = new path(P1,P2);
		Point c;
		if (Collide(P1))
		{ return(false);	}
		while (!Npath.endofpath() )
		{
			c=Npath.next();
			if (Collide(c))
			{ return(false);	}
		}
		return (true);
	}

	public Boolean CanGo_BAD(Point P1,Point P2)
	{
		/* P1 can reach P2 */
		/* P1 see P2 */
	foreach (Wall w in walls)
	{
		path pat = new path(P1,P2);
		if ( ((pat.F_Y(w.X) >= w.Y) & (pat.F_Y(w.X) <= w.Y+w.Hei))
			|
		   ((pat.F_Y(w.X+ w.Wid) >= w.Y) & (pat.F_Y(w.X+ w.Wid) <= w.Y+w.Hei))
			|
		   ((pat.F_X(w.Y+ w.Hei) >= w.X) & (pat.F_X(w.Y+ w.Hei) <= w.X+w.Wid))
			|
		   ((pat.F_X(w.Y) >= w.X) & (pat.F_X(w.Y) <= w.X+w.Wid))
		   )
		return(false);
	}
		return (true);




	}


	public float dist(Point S, Point F)
	{
		return (float)( Math.Sqrt(Math.Pow(F.Y - S.Y,2) + Math.Pow(F.X - S.X,2)) );
	}
	}
}
